#ifndef _LCD_H_
#define _LCD_H_

#include "types.h"

// Port
#define LCD PORTC
#ifdef ADC_TEMPO
#define LCD2 PORTB
#define EN_PIN 0
#else
#define EN_PIN 5
#endif

// Commands
#define LCD_CLEAR 0x01
#define LCD_HOME 0x02
#define LCD_MODE 0x04
#define LCD_ON 0x08
#define LCD_SHIFT 0x10
#define LCD_FUNCSET 0x20

// Text
#define LINESIZE	24
#define TEXTCNT		4

#define DISP_MAIN 	0
#define DISP_WRITE	1
#define DISP_ERROR	2
#define DISP_DONE	3

// Functions
void lcd_data(u08 d);
void lcd_command(u08 c);
void lcd_clear(void);
void lcd_string(u08 idx, u08 row);
void lcd_setcur(u08 x, u08 y);
void lcd_hex_u08(u08 d);
void lcd_hex_u16(u16 d);

#endif
